'fbc -dll test01.bas
#include "Basic4GLPlugin.bi"

const PLUGIN_DESC       = "Test01 Plugin for Basic4GL"
const PLUGIN_MAJOR      = 0
const PLUGIN_MINOR      = 1

extern "C"

private sub AddInt(THIS_RUNTIME)
   'SetIntegerResult(GetIntegerParam(1)+GetIntegerParam(2))
   SIR(GIP(1)+GIP(2))
end sub
' ret=DeletePath$(NewPath$)
private sub AddFloat(THIS_RUNTIME)
  'SetFloatResult(GetFloatParam(1)+GetFloatParam(2))
   SFR(GFP(1)+GFP(2))
end sub

' ##########
' # Plugin #
' ##########


dim shared as IDLL_Basic4GL_Plugin ptr MyPlugin

' register exported Datatypes,Const's,Function's,Sub's
function Load (THIS_PLUGIN , _
               THIS_REGISTRY, _
               blnIsExe as byte) as integer
  ' RegisterFloatConstant(NAME,VALUE)
  RFC (TEST_VERSION,PLUGIN_MAJOR+PLUGIN_MINOR*0.1)
  ' RegisterIntegerConstant(NAME,VALUE)
  RIC(TEST_INT,12345)
  
  'RegisterIntegerFunction(name,address):RegisterIntegerParam,RegisterIntegerParam
  RIF(AddInt,@AddInt):AIP:AIP
  'RegisterIntegerFunction(name,address):RegisterFloatParam,RegisterFloatParam
  RFF(AddFloat,@AddFloat):AFP:AFP
  return 1
end function

' interface
sub Unload (THIS_PLUGIN)
  if MyPlugin then 
    delete MyPlugin
    MyPlugin = 0
  end if
end sub

function Start(THIS_PLUGIN) as integer
  return 1
end function

sub Ends (THIS_PLUGIN)

end sub

sub Pause (THIS_PLUGIN)

end sub

sub Resumed (THIS_PLUGIN)

end sub

sub DelayedResume (THIS_PLUGIN)

end sub

sub GetError  (THIS_PLUGIN,ErrMsg as zstring ptr)

end sub

sub ProcessMessages(THIS_PLUGIN)

end sub

' Query function
function Basic4GL_Query  alias "Basic4GL_Query" (byval details as string, _
                                                 byref major   as integer, _
                                                 byref minor   as integer) as integer export
  dim as string DetailSrc = PLUGIN_DESC
  for i as integer = 0 to len(detailSrc)
    Details[i] = DetailSrc[i]
  next
  major = PLUGIN_MAJOR
  minor = PLUGIN_MINOR
  return BASIC4GL_DLL_VERSION
end function

' Main initialisation function.
' Here we will construct and return our plugin object
function Basic4GL_Init  alias "Basic4GL_Init" () as IDLL_Basic4GL_Plugin ptr ptr export
  ' Construct and return our plugin object
  MyPlugin=new IDLL_Basic4GL_Plugin
  MyPlugin->Load           =@Load
  MyPlugin->Unload         =@Unload
  MyPlugin->Start          =@Start
  MyPlugin->Ends           =@Ends
  MyPlugin->Pause          =@Pause
  MyPlugin->Resumed        =@Resumed
  MyPlugin->DelayedResume  =@DelayedResume
  MyPlugin->GetError       =@GetError
  MyPlugin->ProcessMessages=@ProcessMessages
  return @MyPlugin
end function

end extern




